#include <malloc.h>

#include "sched.h"

int              classcount, profcount, roomcount, exclusionpaircount;
int              studentcount;
int              exclcost,  profcost, spacingcost;
double           rmsizecost, cost, mincost = 10000.0;
double           rcost, rnewcost, dcost, cost_1, cost_2, cost_3;
double           s_cost_old, h_cost_old, h_cost_new, h_cost_old;
int              iters_per_timestep, timesteps, ann_timestep;
double           cooling_factor, temperature, exp_value, boltzmann_value;
double           pow();

STUDENT          *students;
PROFESSOR        *professors;
CLASS            *classes, *saveclasses;
ROOM             *rooms;
 
int              *times;
int              exclusionpairs[MAXEXCLUSIONPAIRS][2];

void main()
{
  printf("\n\n ********************** begin ******************\n");

        if ((times = (int *) malloc(TIMESLOTS * sizeof(int))) == NULL)
	  {
            fprintf(stderr,"No available memory for array %s. \n","times");
            exit(1);
          }

/*****
        if ((exclusionpairs = (int *) malloc(MAXEXCLUSIONPAIRS * sizeof(int))) == NULL)
	  {
            fprintf(stderr,"No available memory for array %s. \n","exclusionpairs");
            exit(1);
          }
*****/

	load_data();

	printf("\n\nRoomcount: %d\t Profcount: %d\t Classcount: %d\t Studentcount: %d\n\n", roomcount, profcount, classcount, studentcount);

	randomly_initialize_schedule();
/*--------------------[1]-----------------------*/
        srand(1000000);		      
	anneal_on_time_room();
        printf("\n\n=========== anneal on TIME and SPACE =================\n\n");
        printf("\n\nCost: %f ExclCost: %f RmSizeCost: %f\n ProfCost: %f SpacingCost: %f  MinCost: %f\n\n",  cost, cost_1, rmsizecost, cost_2, cost_3, mincost);
	fflush(stdout);
        write_schedule();
	fflush(stdout);
/*--------------------[2]----------------------*/
/****
	srand(999999);		 
	anneal_on_time();
        printf("\n\n=========== anneal on TIME  =================\n\n");
	printf("\n\nCost: %f ExclCost: %f RmSizeCost: %f\n ProfCost: %f SpacingCost: %f  MinCost: %f\n\n",  cost, cost_1, rmsizecost, cost_2, cost_3, mincost);
	fflush(stdout);
        write_schedule();
	fflush(stdout);   
****/
/*--------------------[3]----------------------*/
/****
	srand(888888);		 
	anneal_on_space();
        printf("\n\n=========== anneal on SPACE (room)  =================\n\n");
	printf("\n\nCost: %f ExclCost: %f RmSizeCost: %f\n ProfCost: %f SpacingCost: %f  MinCost: %f\n\n",  cost, cost_1, rmsizecost, cost_2, cost_3, mincost);
	fflush(stdout);
        write_schedule();
	fflush(stdout);   
****/
}

/***======================================================***/

load_data()
{
	FILE           *fptr;

	char            tmpchar[STRINGLENGTH];
        char            tmpchar6[FIELDLENGTH];  /* used to read names... */

	int             tmpint, tmpint4, tmpint5, 
                        tmpint6, tmpint7, i ;
	int             tmpint_1, tmpint_2, tmpint_3, tmpint_4, tmpint_5, 
	                tmpint_6, tmpint_7, tmpint_8, tmpint_9, tmpint_10;
        int             tmpint_0, tmpint_11, tmpint_12, tmpint_13;

	int           tmpint1, tmpint2, tmpint3;
	char          tmpchar1[BLD_NAME_LEN], tmpchar2[ROOM_NUM_LEN], 
		      tmpchar3[ROOM_TYPE_LEN], tmpchar4[ROOM_PURPOSE_LEN], 
	              tmpchar5[ROOM_PRIORTIES_LEN]; 
        
        if ((saveclasses = (CLASS *) malloc(2 * sizeof(CLASS))) == NULL)
	  {
           fprintf(stderr,"Can NOT allocate memory for %s  - bye!\n","saveclasses");
           exit(1);
	 }
	if ((rooms = (ROOM *) malloc(PHYSICALROOMS * sizeof(ROOM))) == NULL)
          {
           fprintf(stderr,"Can NOT allocate memory for %s - bye!\n","rooms");
           exit(1);
	 }
	if ((professors = (PROFESSOR *) malloc(MAXNUMPROFS * sizeof(PROFESSOR))) == NULL)
          {
           fprintf(stderr,"Can NOT allocate memory for %s - bye!\n","professors");
           exit(1);
	 }
	if ((classes = (CLASS *) malloc(MAXNUMCLASSES * sizeof(CLASS))) == NULL)
          {
           fprintf(stderr,"Can NOT allocate memory for %s - bye!\n","classes");
           exit(1);
	 }
	if ((students = (STUDENT *) malloc(MAXNUMSTUDENTS * sizeof(STUDENT))) == NULL)
          {
           fprintf(stderr,"Can NOT allocate memory for %s - bye!\n","students");
           exit(1);
	 }
/*----------(1)------------------------------------------------------*/	
/* Read students records from File.                                  */
/* name, ssn, major, numb of classes,  choice classes.               */
/*-------------------------------------------------------------------*/
        studentcount = i = 0;
	if ((fptr = fopen("students.dat","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","students.dat");
           exit(1);
         }              
/*        fptr = fopen("students.dat","r"); */
	while (fscanf(fptr,"%s %ld %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
		      tmpchar6, &tmpint1, &tmpint2, &tmpint3,
		      &tmpint_0, &tmpint_1, &tmpint_2, &tmpint_3,
                      &tmpint_4, &tmpint_5, &tmpint_6, &tmpint_7,
                      &tmpint_8, &tmpint_9, &tmpint_10, &tmpint_11,
                      &tmpint_12, &tmpint_13) != EOF)
	  { 
	  strcpy(students[i].name, tmpchar6);
          students[i].studentid = tmpint1;
	  students[i].major= tmpint2;
          students[i].numb_classes_chosen=tmpint3;
	  students[i].first_choice[0]= tmpint_0;
	  students[i].first_choice[1]= tmpint_1;
	  students[i].first_choice[2]= tmpint_2;
	  students[i].first_choice[3]= tmpint_3;
	  students[i].first_choice[4]= tmpint_4;
	  students[i].first_choice[5]= tmpint_5;
	  students[i].first_choice[6]= tmpint_6;
	  students[i].first_choice[7]= tmpint_7;
	  students[i].first_choice[8]= tmpint_8;
	  students[i].first_choice[9]= tmpint_9;
	  students[i].first_choice[10]= tmpint_10;
	  students[i].first_choice[11]= tmpint_11;
	  students[i].first_choice[12]= tmpint_12;
	  students[i].first_choice[13]= tmpint_13;
          i++;
	}
	fclose(fptr);
        studentcount = i;

/*-----------------(2)---------------------*/
/* Read Class Numbers And Names from File  */
/* class number, class name (or prefix).   */
/*-----------------------------------------*/
        classcount = i = 0;
	if ((fptr = fopen("classes.dat","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","classes.dat");
           exit(1);
         }              
/*	fptr = fopen("classes.dat","r"); */
	while (fscanf(fptr, "%d  %s", &tmpint, tmpchar) != EOF) {
	  strcpy(classes[i].name, tmpchar);
	  classes[i].number = tmpint;
	  i++;
	}
	fclose(fptr);
        classcount = i;
/*-------------(3)----------------------------*/
/* Read Professor Numbers and Names from File */
/* prof number, prof name.                    */
/*--------------------------------------------*/

	profcount = i = 0;
	if ((fptr = fopen("professors.dat","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","professors.dat");
           exit(1);
         }              

    /* tmpint: is the professor number 
       (assuming it is in a sequential order). 
       tmpchar: professor name. Here, also we will assume that
       number of classes taught by the professor is initialized
       to zero. */

/*	fptr = fopen("professors.dat","r");  */
	while (fscanf(fptr, "%d  %s", &tmpint, tmpchar) != EOF) {
		strcpy(professors[i].name, tmpchar);
		professors[i].nclasses = 0;
		professors[i].number = tmpint;
		i++;
	}
	fclose(fptr);
        profcount = i;
/*-----------(4)--------------------*/
/* Read Class Enrollments from File */
/* class number, enrollments size.  */
/*----------------------------------*/
	i = 0;

        /* tmpint1: the class number (sequentially).            */
        /* tmpint2: the size of that class.                    */

	if ((fptr = fopen("enrollments.dat","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","enrollments.dat");
           exit(1);
         }              
/*	fptr = fopen("enrollments.dat","r");  */
	while (fscanf(fptr, "%d %d", &tmpint1, &tmpint2) != EOF) {
	  classes[i].number = tmpint1;
          classes[i].enrollment = tmpint2;                /* ASSUMING */
							/* THINGS IN ORDER! */
	  i++;
	}
	fclose(fptr);

/*------------------(5)-------------------------*/
/* Read Professor/Class Assignments from File   */
/* class number, the assigned professor number. */
/*----------------------------------------------*/
        /* tmpint: the class number (sequentially). tmpint2:
	   number of the professor assigned to the given
	   class. */
        i = 0;

	if ((fptr = fopen("classprof.dat","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","classprof.dat");
           exit(1);
         }              
/*	fptr = fopen("classprof.dat","r");  */
	while (fscanf(fptr, "%d %d", &tmpint1, &tmpint2) != EOF) {
	  classes[i].profnumber = tmpint2;
	  professors[tmpint2].classnumbers[professors[tmpint2].nclasses]
	    = tmpint1;
	  professors[tmpint2].nclasses++;
	  i++;
	}
	fclose(fptr);

/*----------------------(6)--------------------------------------------*/
/* Read Classroom Attributes from File                                 */
/* room number, capacity, presence of AV equipments (5 types).         */
/*---------------------------------------------------------------------*/
	roomcount = i = 0;
	if ((fptr = fopen("rooms.dat","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","rooms.dat");
           exit(1);
         }              
/*	fptr = fopen("rooms.dat","r");  */
	while (fscanf(fptr, "%d %s %s %d %s %s %s", 
		      &tmpint1, tmpchar1, tmpchar2, &tmpint2, 
		      tmpchar3, tmpchar4, tmpchar5) != EOF) {    
		rooms[i].room_tag = tmpint1;
		strcpy(rooms[i].bldg, tmpchar1);
		strcpy(rooms[i].room_num, tmpchar2);
		rooms[i].room_capacity = tmpint2;
		strcpy(rooms[i].room_type, tmpchar3);
		strcpy(rooms[i].room_purpose, tmpchar4);
		strcpy(rooms[i].room_priority, tmpchar5);
                rooms[i].nclasses = 0;
		i++;
	}
	fclose(fptr);
	roomcount = i;

/*------------------------(7)------------------------------------*/
/* Read Class pairs that can't happen at same time               */
/* class number (sequential tag), class number (sequential tag). */
/*---------------------------------------------------------------*/
	exclusionpaircount = i = 0;
	if ((fptr = fopen("execlusive.dat","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","execlusive.dat");
           exit(1);
         }              
	while (fscanf(fptr, "%d %d", exclusionpairs[i], exclusionpairs[i] + 1) != EOF) {
		exclusionpaircount++;
		i++;
	}
	fclose(fptr);
/*-----------------------------(8)-------------------------------------*/
/* read annealing parameters                                           */
/* cooling factor, temp, iter_per_timestep, exp_value, boltzman_value. */
/*---------------------------------------------------------------------*/
	if ((fptr = fopen("parameters.dat","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","parameters.dat");
           exit(1);
         }              
/*	fptr = fopen("parameters.dat","r");  */
	fscanf(fptr, "%lf ", &cooling_factor);
	fscanf(fptr, "%lf ", &temperature);
	fscanf(fptr, "%d ", &iters_per_timestep);
	fscanf(fptr, "%d ", &timesteps);
	fscanf(fptr, "%lf ", &exp_value);
	fscanf(fptr, "%lf ", &boltzmann_value);
	fclose(fptr);
}

/***================================================================***/
randomly_initialize_schedule()
{
	int             i = 0;
	for (i = 0; i < classcount; i++) {
		classes[i].time = i % 10;
		classes[i].room = i % roomcount;
		classes[i].troom = 10 * classes[i].room + classes[i].time;
                rooms[classes[i].room].nclasses++;
	      }
      }

/***================================================================***/
/* float absol(double value) */

float absol(value)
double value;
{
  if (value < 0.0)
    return(-1.0 * value);
  else
    return(value);
}

/***======================***/
energy_type * cost_fn()
{
	int             i, j, k, c1, c2;
	int             max, min;
	energy_type     *energy_cost;

	exclcost = 0;
	rmsizecost = 0.0;
	profcost = 0;
	spacingcost = 0;
	cost_1 = cost_2 = cost_3 = 0.0;

/* -------------(1) --Class Exclusion Pairs------------- */
	for (i = 0; i < exclusionpaircount; i++) {
		c1 = exclusionpairs[i][0];
		c2 = exclusionpairs[i][1];
		if (classes[c1].time == classes[c2].time)
			exclcost++;    /* if the class-pair takes place at the
                                          same time, then cost will incur. 
                                          (timeconflict-cost) */
	}
	cost_1 = (double) exclcost;

/* printf("class exclcost = %f \n", cost_1); */

/* ------------(2) --Adequate Room Size?---------------- */
          /* If a given room capacity is less than student enrollment using
                     that class, then cost will also incur. (roomsize-cost) */

/* ------------(Soft Constraint) : high priority. -------*/

	for (i = 0; i < classcount; i++) {
	  if (classes[i].enrollment > rooms[classes[i].room].room_capacity)

/*----------old formula---------------------------------------------------*/
/* rmsizecost=classes[i].enrollment-rooms[classes[i].room].room_capacity; */
/*------------------------------------------------------------------------*/

/*------------------------New----------------------------------*/
/*---- see Dowsland's paper for the following cost format. ----*/
/*-------------------------------------------------------------*/

	    rmsizecost = 
	      absol(sin((double) classes[i].enrollment * (PI/rooms[classes[i].room].room_capacity)));
	}

/* printf(" rmsizecost = %f \n", rmsizecost); */

/* ----------------------------------------------------------------- */
/* ---- (3) --Prof teaching more than 1 class at a time?------------ */
/* ----------(Hard Constraint) ------------------------------------- */
/* If a professor is assigned to more than class at the same time.   */
/* ----------------------------------------------------------------- */

	for (i = 0; i < profcount; i++) {
	  for (j = 0; j < professors[i].nclasses; j++) {
	    for (k = j + 1; k < professors[i].nclasses; k++) {
	      if (classes[professors[i].classnumbers[j]].time ==
		  classes[professors[i].classnumbers[k]].time)
		profcost++;
	    }
	  }
	}
	cost_2 = (double) profcost;

/* printf("Profcost: %f \n", cost_2); */

/*---- Overall Class Schedule Time Spacing -------------------------*/

	for (i = 0; i < TIMESLOTS; i++)
	  times[i] = 0;

	for (i = 0; i < classcount; i++) 
	  times[classes[i].time]++;

/*----(4) -- cost incurred from spacing between various time-slots -*/
/*------ (Soft Constraint): low priority ---------------------------*/

	max = 0;
	min = 100000;		/* KLUDGY ?? */
	for (i = 0; i < TIMESLOTS; i++) {
/* printf(" spacing max = %d ,   spacing min = %d \n", max, min); */
	  if (times[i] > max)
	    max = times[i];
	  if (times[i] < min)
	    min = times[i];
	}
	spacingcost = (max - min);

/* printf(" class spacingcost = %d \n", spacingcost); */

        if (spacingcost==1) 
	  spacingcost = 0;

	cost_3 = (double) spacingcost;

/*------ Dynamic memory allocation for the cost structure. -------*/

energy_cost = (energy_type *) malloc(sizeof(energy_type));

/*----------------------------------------------------------------*/

energy_cost->total_cost = 
  400.0 * cost_1 + 350.0 * cost_2  + 250.0 * rmsizecost + 100.0 * cost_3;
energy_cost->hard_cost = 
  400.0 * cost_1 + 350.0 * cost_2;
energy_cost->soft_cost = 
  250.0 * rmsizecost + 100.0 * cost_3;

/*  -----------  */

        if (energy_cost->total_cost < mincost) 
	  mincost = energy_cost->total_cost;   /* For record keeping:  */

/* if cost reduces the update current cost,
	   otherwise don't.   */

	return (energy_cost);
}

/***====================================================================***/
anneal_on_time_room()
{
	FILE            *fptr;
        int             swap1 =0, swap2 = 0, j = 0, counter = 0,  i = 0;
        double          dice = 0.0, delta_cost = 0.0;
	energy_type     *cost_ptr;
        srand48(1000000);
	cost = 0.0;     /* defined globally */
      
/*----------------------------------------------------------
    Let S = solution space. f = objective function. and N = set
    of neighborhood structures.
------------------------------------------------------------*/  
	counter = 0;

        for (ann_timestep = 0; ann_timestep < timesteps; ann_timestep++) {
	  for (j = 0; j < iters_per_timestep; j++) {
	    cost_ptr = cost_fn();  
	    rcost = cost_ptr->total_cost;    /* (1) compute the total cost of the 
                                                current solution space S_0
                                                = f(S_0) */
	    h_cost_old = cost_ptr->hard_cost;
/*-------------------------------------------------------
   Note: this condition can act as a stopping criterion.
   when executed it will terminate the routine and
   return to the caller.
---------------------------------------------------------*/
	    if (rcost == 0.0) return;  
                                        /* (2) randomly select a new solution
                                           space S_1 \in N, by doing a random
                                           swapping of classes. */
	    do {
	      swap1 = (rand() % MAXNUMCLASSES);
	      swap2 = (rand() % MAXNUMCLASSES);
	    } while (swap1 == swap2);

	    bcopy(&(classes[swap1]), &(saveclasses[0]), sizeof(CLASS));
	    bcopy(&(classes[swap2]), &(saveclasses[1]), sizeof(CLASS));
	    bcopy(&(classes[swap2]), &(classes[swap1]), sizeof(CLASS));
	    bcopy(&(saveclasses[0]), &(classes[swap2]), sizeof(CLASS));

	    cost_ptr = cost_fn();  
	    rnewcost = cost_ptr->total_cost;         /* (3) compute the total cost of the
                                                         current solution space S_1 
                                                         = f(S_1) */
	    h_cost_new = cost_ptr->hard_cost;

	    delta_cost =(double) rnewcost - rcost;   /* (4) compute the difference
                                                          between the 2 costs:
                                                          delta = f(S_1) - f(S_0) */

	    if (delta_cost <= 0.0)   /* ??? may be also <=  ??? */
	      {
                                                     /* (5) set S_0 = S_1 */
		bcopy(&(classes[swap1]),&(classes[swap2]),sizeof(CLASS));
		bcopy(&(saveclasses[0]),&(classes[swap1]),sizeof(CLASS));
	      }
	    else
	      {
		dice = (double) drand48();           /* (6) generate random number. */
		dcost = (double) 
		  pow((double) exp_value, - (double) delta_cost/temperature); 

		if (dice < dcost) 
		  {
		                                     /* (7) set S_0 = S_1 */
		    bcopy(&(classes[swap1]),&(classes[swap2]),sizeof(CLASS));
		    bcopy(&(saveclasses[0]),&(classes[swap1]),sizeof(CLASS));
		  } 
		else
		  continue;       /* automatically accepted. No swaps
                                     are done.  */
	      }
	  }
	  counter++;
/* ------------- (8) update the temperature cooling schedule ------ */
/*-------see Bill Spears' paper.... ---------------
  temperature = 
  temperature * (double) pow((double) exp_value, - (double) counter * cooling_factor); 
---------------------------------------------------*/

/*--------The geometric cooling schedule. --------------*/

	  temperature = temperature * cooling_factor;  

/* temperature = temperature/(1.0 + temperature);  */
/* printf("Outer-loop counter = %d , Temperature = %lf\n ",counter, temperature); */

	}
	cost = cost_ptr->total_cost; 
      }

/*****************************--------*****************************/
/*****************************--------*****************************/
anneal_on_time()
{
        int             swap1, swap2, j;
        double          dice, delta_cost;
	energy_type     *cost_ptr;
        srand48(999999);
      	cost = 0.0;
/*----------------------------------------------------------
    Let S = solution space. f = objective function. and N = set
    of neighborhood structures.
------------------------------------------------------------*/  

        for (ann_timestep = 0; ann_timestep < timesteps; ann_timestep++) {
	  for (j = 0; j < iters_per_timestep; j++) {
	
	    cost_ptr = cost_fn();  
	    rcost = cost_ptr->total_cost; /* (1) compute the total cost of the 
                                                current solution space S_0
                                                = f(S_0) */
/*-------------------------------------------------------
   Note: this condition can act as a stopping criterion.
   when executed it will terminate the routine and
   return to the caller.
---------------------------------------------------------*/
	    if (rcost == 0.0) return;  
                                        /* (2) randomly select a new solution
                                           space S_1 \in N, by doing a random
                                           swapping of classes. */
	    do {
	      swap1 = (rand() % MAXNUMCLASSES);
	      swap2 = (rand() % MAXNUMCLASSES);
	    } while (swap1 == swap2);

	    saveclasses[0].time = classes[swap1].time;
	    saveclasses[1].time = classes[swap2].time;

	    classes[swap1].time = classes[swap2].time;   /* swap time-slot (TIME)  */
	    classes[swap2].time = saveclasses[0].time;   /* swap time-slot (TIME)  */

	    cost_ptr = cost_fn();  
	    rnewcost = cost_ptr->total_cost;     /* (3) compute the total cost of the
                                                    current solution space S_1 
                                                    = f(S_1) */

	    delta_cost =(double) rnewcost - rcost;    /* (4) compute the difference
                                                            between the 2 costs:
                                                            delta = f(S_1) - f(S_0) */

	    if (delta_cost <= 0.0)   /* ??? may be also <=  ??? */
	      {
                                              /*---- (5) set S_0 = S_1 ----*/
		classes[swap2].time = classes[swap1].time; 
		classes[swap1].time = saveclasses[0].time; 
	      }
	    else
	      {
		dice = (double) drand48();    /*---- (6) generate random number. ----*/

		dcost = (double) 
		  pow((double) exp_value, - (double) delta_cost/temperature); 


		if (dice < dcost) 
		  {
		                                /* (7) set S_0 = S_1 */
		    classes[swap2].time =  classes[swap1].time; 
		    classes[swap1].time =  saveclasses[0].time; 
		  } 
		else
		  continue;       /* automatically accepted. No swaps
                                     are done.  */
	      }
	  }

/*---- (8) update the temperature -- cooling schedule ----*/

	  temperature = temperature * cooling_factor;  

	}
	cost = cost_ptr->total_cost; 
      }

/*****************************--------*****************************/
/*****************************--------*****************************/
anneal_on_space()
{
        int             swap1, swap2, j;
        double          dice, delta_cost;
	energy_type     *cost_ptr;
        srand48(888888);

      	cost = 0.0;
/*----------------------------------------------------------
    Let S = solution space. f = objective function. and N = set
    of neighborhood structures.
------------------------------------------------------------*/  

        for (ann_timestep = 0; ann_timestep < timesteps; ann_timestep++) {
	  for (j = 0; j < iters_per_timestep; j++) {
	
	    cost_ptr = cost_fn();  

	    rcost = cost_ptr->total_cost; 
                                         /* (1) compute the total cost of the 
                                                current solution space S_0
                                                = f(S_0) */
/*-------------------------------------------------------
   Note: this condition can act as a stopping criterion.
   when executed it will terminate the routine and
   return to the caller.
---------------------------------------------------------*/
	    if (rcost == 0.0) return;  

                                        /* (2) randomly select a new solution
                                           space S_1 \in N, by doing a random
                                           swapping of classes. */
	    do {
	      swap1 = (rand() % MAXNUMCLASSES);
	      swap2 = (rand() % MAXNUMCLASSES);
	    } while (swap1 == swap2);

	    saveclasses[0].room = classes[swap1].room;
	    saveclasses[1].room = classes[swap2].room;

	    classes[swap1].room = classes[swap2].room;   /* swap room-slot (ROOM)  */
	    classes[swap2].room = saveclasses[0].room;   /* swap room-slot (ROOM)  */

	    cost_ptr = cost_fn();  
	    rnewcost = cost_ptr->total_cost;     /* (3) compute the total cost of the
                                                    current solution space S_1 
                                                    = f(S_1) */

	    delta_cost =(double) rnewcost - rcost;    /* (4) compute the difference
                                                            between the 2 costs:
                                                            delta = f(S_1) - f(S_0) */

	    if (delta_cost <= 0.0)   /* ??? may be also <=  ??? */
	      {
                                              /*---- (5) set S_0 = S_1 ----*/
		classes[swap2].room = classes[swap1].room; 
		classes[swap1].room = saveclasses[0].room; 
	      }
	    else
	      {
		dice = (double) drand48();    /*---- (6) generate random number. ----*/

		dcost = (double) 
		  pow((double) exp_value, - (double) delta_cost/temperature); 


		if (dice < dcost) 
		  {
		                                /* (7) set S_0 = S_1 */
		    classes[swap2].room =  classes[swap1].room; 
		    classes[swap1].room =  saveclasses[0].room; 
		  } 
		else
		  continue;       /* automatically accepted. No swaps
                                     are done.  */
	      }
	  }

/*---- (8) update the temperature -- cooling schedule ----*/

	  temperature = temperature * cooling_factor;  

	}
	cost = cost_ptr->total_cost; 
      }

/*****==========================================================****/
/*****==========================================================****/

write_schedule()
{
        int    time_only = 0, i = 0, j = 0, k = 0;
/***
	for (i = 0; i < studentcount; i++) {
	  printf("Student_name: %s\n", students[i].name);
	  printf("Student_ID: %ld\n", students[i].studentid);
	  printf("Major: %d\n", students[i].major);
          printf("Number of classes chosen: %d\n", students[i].numb_classes_chosen);
	  printf("The student first class choices: \n");
	  
	  for(j = 0; j < students[i].numb_classes_chosen; j++){
	    printf("%d\t", students[i].first_choice[j]);
	  }
	  printf("\n===================================\n");
	}
***/
	for (i = 0; i < roomcount; i++) {
	  for(j = 0; j < TIMESLOTS; j++) {       /* timeslots per day */
	    for( k=0; k < classcount; k++) {
	      if ((classes[k].time == j ) && (classes[k].room == i )) 
               {  /*   i<-->j  the time and space coincide. */

		printf("Class Timeslot: %d\n",classes[k].time);
		printf("Room number: %d\t  Room Size: %d\n",classes[k].room,rooms[classes[k].room].room_capacity);
		if (classes[k].enrollment > rooms[classes[k].room].room_capacity)
      		    printf("WARNING: OVER CAPACITY\n");
                printf("Enrollment: %d\n",classes[k].enrollment);
                printf("Professor number: %s\n",professors[classes[k].profnumber]);
		printf("Number (serial): %d    (k=%d)\n", classes[k].number,k);
		printf("Class_name: %s\n", classes[k].name);
		printf("Room(xxx)Time(y) [xxxy]: %d  \n\n", classes[k].troom); 

	      }
	    }
	  }
	  printf("============= End Record of room %d ============\n", i);
        }
/****
	printf("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n");
	for (i= 0; i < studentcount; i++) {
	  printf("student_ID (SSN): %ld\n", students[i].studentid);
	  for (j = 0; j < students[i].numb_classes_chosen; j++) {
 printf("class_choice: %d  Prof_name: %s  Room_number: %d   Class_time: %d\n", j, 
  professors[classes[students[i].first_choice[j]].profnumber].name,
  classes[students[i].first_choice[j]].room, classes[students[i].first_choice[j]].time);
	  }
	  printf("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
	  }
****/
	fflush(stdout);
}



/***===============================================***/
write_schedule_time()
{
        int    time_only = 0, i, j, k;


	/*--
	for (i = 0; i < studentcount; i++) {
	  printf("Student_name: %s\n", students[i].name);
	  printf("Student_ID: %ld\n", students[i].studentid);
	  printf("Major: %d\n", students[i].major);
          printf("Number of Classes:  %d\n", students[i].numb_classes_chosen);
	  printf("The student first choices: \n");
	  
	  for(j = 0; j < students[i].numb_classes_chosen; j++){
	    printf("%d\t", students[i].first_choice[j]);
	    }
	  printf("\n===================================\n\n");
	}
        --*/

	for (i = 0; i < roomcount; i++) {
	/*  printf("\n++++++++++++++++++ Room: (%d) ++++++++++++++++++\n\n", i); */
	  for(j = 0; j < 10; j++) {
	    for( k=0; k < roomcount * 10; k++) {
        if ( (classes[k].time == j ) && (classes[k].room == i )) 
          {  /* i<--> j*/

		printf("Current_Time: %d\n",classes[k].time);
printf("Room: %d\tRoom Size: %d\n",classes[k].room,rooms[classes[k].room].room_capacity);
		if (classes[k].enrollment > rooms[classes[k].room].room_capacity)
		    printf("WARNING: OVER CAPACITY\n");
                printf("Enrollment: %d\n",classes[k].enrollment);
                printf("Professor: %s\n",professors[classes[k].profnumber]);

		printf("Number: %d    (k=%d)\n", classes[k].number,k);
		printf("Class_name: %s\n", classes[k].name);
		time_only = classes[k].troom / 100;
printf("Time-Room: %d  ,  Previous_Time: %d \n-----------\n", classes[k].troom, time_only); 

	      }
      }
  }
	  printf("\n");
 }


	printf("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
	for (i= 0; i < studentcount; i++) {
	  printf("student_ID : %ld\n", students[i].studentid);
          for (j = 0; j < students[i].numb_classes_chosen; j++) {
	    printf("Class_choice: %d  Prof_name: %s  Room_number: %d\n", j, 
	      professors[classes[students[i].first_choice[j]].profnumber].name,
		   classes[students[i].first_choice[j]].room);
	  }
	  printf("\n");
	  printf("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
	}

	fflush(stdout);
}

/***===============================================***/
write_schedule_room()
{
        int    time_only = 0, i, j, k;


	/*
	for (i = 0; i < studentcount; i++) {
	  printf("Student_name: %s\n", students[i].name);
	  printf("Student_ID: %ld\n", students[i].studentid);
	  printf("Major: %d\n", students[i].major);
	  printf("The student first choices: \n");

	  for(j = 0; j < students[i].numb_classes_chosen; j++){
	    printf("%d\t", students[i].first_choice[j]);
	  }
	  printf("\n===================================\n\n");
	}
        */

	for (i = 0; i < roomcount; i++) {
/*	  printf("\n++++++++++++++++++ Room: (%d) ++++++++++++++++++\n\n", i); */
	  for(j = 0; j < 10; j++) {
	    for( k=0; k < roomcount * 10; k++) {
	      if ( (classes[k].time == j ) && (classes[k].room == i )) 
              {  /* i<-->j */
		printf("Current_Time: %d\n",classes[k].time);
		printf("current_Room: %d\tcurrent_Room Size: %d\n",classes[k].room,rooms[classes[k].room].room_capacity);
		if (classes[k].enrollment > rooms[classes[k].room].room_capacity)
		    printf("WARNING: current room OVER CAPACITY\n");
                printf("Enrollment: %d\n",classes[k].enrollment);
                printf("Professor: %s\n",professors[classes[k].profnumber]);

		printf("Number: %d    (k=%d)\n", classes[k].number,k);
		printf("Class_name: %s\n", classes[k].name);
		time_only = classes[k].troom / 100;
		printf("Time-Room (both previous): %d  ,  Previous_Time: %d \n-----------\n", classes[k].troom, time_only); 

	      }
	    }
	  }
	  printf("\n");
        }

	printf("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
	for (i= 0; i < studentcount; i++) {
	  printf("student_ID : %ld\n", students[i].studentid);
	  for (j = 0; j < students[i].numb_classes_chosen; j++) {
	    printf("Class_choice: %d  Prof_name: %s  current_Room_number: %d\n", j, 
	      professors[classes[students[i].first_choice[j]].profnumber].name,
		   classes[students[i].first_choice[j]].room);
	  }
	  printf("\n");
	  printf("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
	}

	fflush(stdout);
}
/***=======================================***/
#ifdef FOOBAR
tmpchar = classnames;
tmpint  = classnumbers;
for (i = 0; i < classcount; i++) {
  printf("Class #:%d\t\t Class Name: %s\n", *tmpint, tmpchar);
  tmpchar += STRINGLENGTH;
  tmpint++;
}
#endif				/* FOOBAR */







